Subject: Re: [sieve] New Version Notification - draft-ietf-sieve-convert-03.txt

From: "Barry Leiba" <[email-masked]>
Date: Mon, 19 Sep 2011 22:53:44 +0000

Sorry for the empty reply first: getting used to a new BlackBerry.

> This creates a new time of Sieve action, a "testable action".
>
> s/time/type

Doh!  Thanks.

> I though we were talking about a test which doesn't perform any conversion. I am 
> uneasy about tests with side effects (modulo setting match variables).

I *think* everyone else who replied understood what I was suggesting, but maybe not.  Others can comment, and I hope they will.

I personally prefer the simplicity of doing the action and test together.  That said, I'm happy to specify that the test not take the action, if that's the WG consensus.

I see a problem with that approach: the test can determine whether the conversion is supported without performing it.  But it can't determine whether it will succeed until it performs it.  If the input is corrupted or mislabelled, how do we have a condition on that?  Would it always have to make the script fail with a runtime error?

So I'm looking for others to weigh in.  Do you prefer the action to be taken along with the test?  Or do you prefer having to repeat the text, once for the test and again to do the action?

Barry

---

From: Likepeng <[email-masked]>
Date: Tue, 20 Sep 2011 00:34:17 +0000

> Do you prefer the action to be taken along with the test?  Or do you prefer having to repeat the text, once for the test and again to do the action?

I prefer the action to be taken along with the test.

Kind Regards
Kepeng

---

From: Stephan Bosch <[email-masked]>
Date: Tue, 20 Sep 2011 03:25:20 +0200

> So I'm looking for others to weigh in.  Do you prefer the action to be taken along with the test?  Or do you prefer having to repeat the text, once for the test and again to do the action?

I'd like the test to have the action side-effect.  That is indeed also 
what I understood from your initial query. I agree that first testing 
and then performing the action is much of a hassle, both for the 
implementer of the Sieve interpreter and the Sieve script author.

 From what I see in RFC5228 section 14 and in the old RFC3028, tests 
having side-effects were originally forbidden explicitly, but are 
allowed now as per RFC5228. I guess there is a reason for this. However, 
to my knowledge, this is the first time this line is truly crossed, so I 
understand Alexey's reservations. Anyway, I do think the advantages 
outweigh the concerns in this case.

Regards,

Stephan

---

From: Barry Leiba <[email-masked]>
Date: Fri, 23 Sep 2011 12:49:55 -0400

>> So I'm looking for others to weigh in.  Do you prefer the action to be
>> taken along with the test?  Or do you prefer having to repeat the text, once
>> for the test and again to do the action?
>
> I'd like the test to have the action side-effect.  That is indeed also what
> I understood from your initial query. I agree that first testing and then
> performing the action is much of a hassle, both for the implementer of the
> Sieve interpreter and the Sieve script author.

Any others?  Cyrus, I understood you to agree that the testable action
mechanism was reasonable.  Is that right?  Others?  Once we resolve
this, I'll post an -04 (with Hannah's correction, at least) that we
can send to the IESG.  Everyone, comment, please.

Barry

---

From: Cyrus Daboo <[email-masked]>
Date: Fri, 23 Sep 2011 14:31:40 -0400

Hi Barry,

> can send to the IESG.  Everyone, comment, please.

There was no objection in feedback I received from implementors, so I am OK 
with it.

-- 
Cyrus Daboo

---

From: Alexey Melnikov <[email-masked]>
Date: Sat, 24 Sep 2011 14:26:08 +0100

Stephan Bosch wrote:

>> I personally prefer the simplicity of doing the action and test 
>> together.  That said, I'm happy to specify that the test not take the 
>> action, if that's the WG consensus.
>>
>> I see a problem with that approach: the test can determine whether 
>> the conversion is supported without performing it.  But it can't 
>> determine whether it will succeed until it performs it.  If the input 
>> is corrupted or mislabelled, how do we have a condition on that?  
>> Would it always have to make the script fail with a runtime error?
>>
>> So I'm looking for others to weigh in.  Do you prefer the action to 
>> be taken along with the test?  Or do you prefer having to repeat the 
>> text, once for the test and again to do the action?
>
> allowed now as per RFC5228. I guess there is a reason for this. 
> However, to my knowledge, this is the first time this line is truly 
> crossed, so I understand Alexey's reservations. Anyway, I do think the 
> advantages outweigh the concerns in this case.

Ok. I suppose I can live with this.